#08.19.10 01.20 chap2.r
#Copyright 2010 by Robert A LaBudde, all rights reserved
#Intro to Bootstrap, Chapter 2 examples
#created: 08.19.10 by R.A. LaBudde
#changes:

#EXAMPLE 2.1.1: Bias correction
set.seed(5^13)  #set random seed so example reproducible
n<- 25    #small sample
x<- rnorm(n)  #random sample of unit normal variate
x
varx<- var(x)*(n-1)/n  #sample variance, uncorrected
c(varx, varx - 1.0, -1/sqrt(n))   #sample variance and bias relative to true value of 1.0 and expected value of bias

B<- 5000  #number of bootstrap resamples
bvarx<- NULL  #initialize resample variances vector
for (i in 1:B) {  #for each resample
  xstar<- sample(x, n, replace=TRUE) #generate resample of size n from data
  bvarx[i]<- var(xstar)*(n-1)/n   #resample variance, uncorrected
}
thetastar<- mean(bvarx)   #estimate of variance
c(thetastar, thetastar - varx)    #resample variance estimate and bias estimate

#EXAMPLE 2.1.1-2: Jackknife
require('bootstrap')
theta<- function(x) var(x)*(n-1)/n  #uncorrected variance
jack<- jackknife(x, theta) #use data from Example 2.1-1
jack
jvarx<- mean(jack$jack.values)
c(jvarx, jvarx - varx)


