#12.03.10 00.45 chap5.r
#copyright 2010 by Robert A LaBudde, all rights reserved
#Intro to Bootstrap, Chap. 5
#created: 12.03.10 by r.a. labudde
#changes:

require('boot')

#EXAMPLE 5.4.1: MSM CHICKEN
c18<- read.table('c18.txt', header=TRUE)
head(c18)
tsc18<- ts(c18)   #convert to time series object

a1<- acf(tsc18)  #autocorrelation function
a1
plot(a1)

p1<- pacf(tsc18)  #partial autocorrelation function
p1
plot(p1)

fit1<- arima(tsc18, order=c(1,0,0)) #fit with AR(1)
fit1
confint(fit1) #95% CI on coefs

ar1 <- ar(tsc18, order.max=1) #fit AR(1)
armodel <- list(order=c(1,0,0),ar=ar1$ar)
arres <- ar1$resid
arres <- arres - mean(arres)  #center

bootf<- function (tsb) {  #statistic for time-series bootstrap
  fit<- arima(tsb, order=c(1,0,0))  #fit with AR(1)
  return(coef(fit)[1])
}
bootsim <- function(res, n.sim, ran.args) {
# random generation of replicate series using arima.sim 
     rg1 <- function(n, res) sample(res, n, replace=TRUE)
     ts.orig <- ran.args$ts
     ts.mod <- ran.args$model
     mean(ts.orig)+ts(arima.sim(model=ts.mod, n=n.sim, rand.gen=rg1, res=as.vector(res)))
}
boot1<- tsboot(tsc18, bootf, R=1000, sim="model", n.sim=nrow(tsc18), orig.t=FALSE, ran.gen=bootsim, 
          ran.args=list(ts=tsc18, model=armodel))
mean(boot1$t[,1]) #mean estimate
quantile(boot1$t[,1], probs=c(0.025,0.975)) #Efron percentile CI on coefficient

boot2<- tsboot(tsc18, bootf, R=1000, l=16, sim="fixed") #block bootstrap with block length = 16
mean(boot2$t[,1]) #mean estimate
quantile(boot2$t[,1], probs=c(0.025,0.975)) #Efron percentile CI on coefficient


#EXAMPLE 5.5: Nasdaq
nasdaq<- read.csv('nasdaq.csv', header=TRUE)
nasdaq$lnClose<- log(nasdaq$Close)
head(nasdaq)
summary(nasdaq)


